/* xwGUI -- an X11-GUI for photo prints
 * Copyright (C) 2001 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _XWDRIVER_XWTOOLS_H
#define _XWDRIVER_XWTOOLS_H

#include <forms.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

/* xwTools Installation Path */
#ifndef xwToolsPath
#define xwToolsPath        "/usr/local/lib/xw"
#endif
#ifndef xwSpaces
#define xwSpaces           "                                        "
#endif

/* DESC GUI */
typedef struct descform
{
   /* Main-Form data */
   FL_FORM           *form;
   /* Event Loop */
   FL_OBJECT         *obj;
   int               ready;

   FL_OBJECT         *DESC;
   FL_OBJECT         *DEVICE;
   FL_OBJECT         *COMMENT;

   FL_OBJECT         *Browser;
   FL_OBJECT         *OK;
} descform;

/* xwTools - Progressbar */
void xwToolsProgress(FL_OBJECT *obj);
/* Get Spool Printers */
void xwToolsInfo(void);
/* build browser line */
char *xwBuildBrowserLine(char *file);
/* read description file */
void xwReadDescription(char *file);

#endif